#include <Servo.h>
#include <Wire.h>
#include <I2Cdev.h>
#include "Arduino_NineAxesMotion.h"

/* Assign a unique ID to this sensor at the same time */

NineAxesMotion mySensor;         //Object that for the sensor

unsigned long lastStreamTime = 0;     //To store the last streamed time stamp
const int streamPeriod = 20;
Servo servo0;
Servo servo1;
Servo servo2;
int servoValues[3];
int servoPos = 0; //
int compassCorrection = 0; // set to 0 (not used)
float ypr[3];// [yaw, pitch, roll]   yaw/pitch/roll containerint heading= mySensor.readEulerHeading

void setup(void)
{


//Peripheral Initialization
Serial.begin(115200);           //Initialize the Serial Port to view information on the Serial Monitor
Wire.begin();                    //Initialize I2C communication to the let the library communicate with the sensor.
//Sensor Initialization
mySensor.initSensor();          //The I2C Address can be changed here inside this function in the library
mySensor.setOperationMode(OPERATION_MODE_NDOF);   //Can be configured to other operation modes as desired
mySensor.setUpdateMode(AUTO);  //The default is AUTO. Changing to MANUAL requires calling the relevant update functions prior to calling the read functions
//Setting to MANUAL requires fewer reads to the sensor
servo0.attach (5);
servo1.attach(6);
servo2.attach(9);
pinMode (5, OUTPUT);
pinMode (6, OUTPUT);
pinMode (9, OUTPUT);
ypr[0];
ypr[1];
ypr[2];
#define heading = (ypr[0]);
}
void loop(void)
{
  /* Get a new sensor event */
  mySensor.updateEuler();        //Update the Euler data into the structure of the object
  mySensor.updateCalibStatus();  //Update the Calibration Status
  Serial.print("Time: ");
  // Serial.print(lastStreamTime);
  //Serial.print("ms ");

  Serial.print(" H: ");
  Serial.print(mySensor.readEulerHeading()); //Heading data
  Serial.print("deg ");

  Serial.print(" R: ");
  Serial.print(mySensor.readEulerRoll()); //Roll data
  Serial.print("deg");

  Serial.print(" P: ");
  Serial.print(mySensor.readEulerPitch()); //Pitch data
  Serial.print("deg ");

  Serial.print(" A: ");
  Serial.print(mySensor.readAccelCalibStatus());  //Accelerometer Calibration Status (0 - 3)

  Serial.print(" M: ");
  Serial.print(mySensor.readMagCalibStatus());    //Magnetometer Calibration Status (0 - 3)

  Serial.print(" G: ");
  Serial.print(mySensor.readGyroCalibStatus());   //Gyroscope Calibration Status (0 - 3)

  Serial.print(" S: ");
  Serial.print(mySensor.readSystemCalibStatus());   //System Calibration Status (0 - 3)

  Serial.println();
  // Get Yaw, Pitch and Roll values from the sensor      {*5}
  ypr[0] = (mySensor.readEulerHeading()); //Heading data
  ypr[1] = (mySensor.readEulerRoll()); //Roll data
  ypr[2] = (mySensor.readEulerPitch()); //Pitch data


if ((ypr[0] - compassCorrection) >= 0)
{
  ypr[0] = (ypr[0]  - compassCorrection);
}
else
{
  ypr[0] = (ypr[0] - compassCorrection + 360);
}

Serial.print(ypr[0]); 
Serial.println(ypr[0]);

// Calculate corresponding servo position

if (ypr[0] > 90 && ypr[0] < 270)
{
  if (ypr[0] <= 180)
  {
    servoPos = 180;
  }
  else
  {
    servoPos = 10;
  }
}
else
{
  if (ypr[0] <= 90)
  {
    servoPos = map(ypr[0], 0, 90, 85, 10);
  }
  else
  {
    servoPos = map(ypr[0], 360, 270, 85, 180);
  }
}
servo0.write(servoPos);
delay(10);
}
